// CheckStyle: stop header check
// GENERATED CONTENT - DO NOT EDIT
// Source: AMD64HotSpotNodeLIRBuilder.java
package com.oracle.graal.hotspot.amd64;

import java.util.*;
import com.oracle.graal.compiler.match.*;
import com.oracle.graal.compiler.gen.NodeLIRBuilder;
import com.oracle.graal.graph.NodeClass;
import com.oracle.graal.hotspot.nodes.*;
import com.oracle.graal.nodes.*;
import com.oracle.graal.nodes.calc.*;
import com.oracle.graal.nodes.extended.*;

public class AMD64HotSpotNodeLIRBuilder_MatchStatementSet implements MatchStatementSet {

    private static final String[] ifCompareCompressedMemory_arguments = new String[] {"root", "compare", "compress", "value", "location", "access"};
    private static final class MatchGenerator_ifCompareCompressedMemory implements MatchGenerator {
        static MatchGenerator instance = new MatchGenerator_ifCompareCompressedMemory();
        public ComplexMatchResult match(NodeLIRBuilder builder, Object...args) {
            return ((AMD64HotSpotNodeLIRBuilder) builder).ifCompareCompressedMemory((IfNode) args[0], (CompareNode) args[1], (CompressionNode) args[2], (ValueNode) args[3], (ConstantLocationNode) args[4], (Access) args[5]);
        }
        public String getName() {
             return "ifCompareCompressedMemory";
        }
    }

    private static final String[] binaryReadCompressed_arguments = new String[] {"root", "value", "access", "compress", "location"};
    private static final class MatchGenerator_binaryReadCompressed implements MatchGenerator {
        static MatchGenerator instance = new MatchGenerator_binaryReadCompressed();
        public ComplexMatchResult match(NodeLIRBuilder builder, Object...args) {
            return ((AMD64HotSpotNodeLIRBuilder) builder).binaryReadCompressed((BinaryNode) args[0], (ValueNode) args[1], (Access) args[2], (CompressionNode) args[3], (ConstantLocationNode) args[4]);
        }
        public String getName() {
             return "binaryReadCompressed";
        }
    }

    private static final String[] readCompressed_arguments = new String[] {"root", "compress", "location"};
    private static final class MatchGenerator_readCompressed implements MatchGenerator {
        static MatchGenerator instance = new MatchGenerator_readCompressed();
        public ComplexMatchResult match(NodeLIRBuilder builder, Object...args) {
            return ((AMD64HotSpotNodeLIRBuilder) builder).readCompressed((Access) args[0], (CompressionNode) args[1], (ConstantLocationNode) args[2]);
        }
        public String getName() {
             return "readCompressed";
        }
    }

    private static final String[] writeCompressed_arguments = new String[] {"root", "compress", "location", "value"};
    private static final class MatchGenerator_writeCompressed implements MatchGenerator {
        static MatchGenerator instance = new MatchGenerator_writeCompressed();
        public ComplexMatchResult match(NodeLIRBuilder builder, Object...args) {
            return ((AMD64HotSpotNodeLIRBuilder) builder).writeCompressed((Access) args[0], (CompressionNode) args[1], (ConstantLocationNode) args[2], (ValueNode) args[3]);
        }
        public String getName() {
             return "writeCompressed";
        }
    }

    public Class<? extends NodeLIRBuilder> forClass() {
        return AMD64HotSpotNodeLIRBuilder.class;
    }

    @Override
    public List<MatchStatement> statements(MatchRuleRegistry.NodeClassLookup lookup) {
        NodeClass.Position[] IfNode_positions = MatchRuleRegistry.findPositions(lookup, IfNode.class, new String[]{"condition"});
        NodeClass.Position[] IntegerEqualsNode_positions = MatchRuleRegistry.findPositions(lookup, IntegerEqualsNode.class, new String[]{"x", "y"});
        NodeClass.Position[] FloatingReadNode_positions = MatchRuleRegistry.findPositions(lookup, FloatingReadNode.class, new String[]{"object", "location"});
        NodeClass.Position[] CompressionNode_positions = MatchRuleRegistry.findPositions(lookup, CompressionNode.class, new String[]{"value"});
        NodeClass.Position[] IntegerLessThanNode_positions = MatchRuleRegistry.findPositions(lookup, IntegerLessThanNode.class, new String[]{"x", "y"});
        NodeClass.Position[] IntegerBelowNode_positions = MatchRuleRegistry.findPositions(lookup, IntegerBelowNode.class, new String[]{"x", "y"});
        NodeClass.Position[] FloatEqualsNode_positions = MatchRuleRegistry.findPositions(lookup, FloatEqualsNode.class, new String[]{"x", "y"});
        NodeClass.Position[] FloatLessThanNode_positions = MatchRuleRegistry.findPositions(lookup, FloatLessThanNode.class, new String[]{"x", "y"});
        NodeClass.Position[] ReadNode_positions = MatchRuleRegistry.findPositions(lookup, ReadNode.class, new String[]{"object", "location"});
        NodeClass.Position[] IntegerAddNode_positions = MatchRuleRegistry.findPositions(lookup, IntegerAddNode.class, new String[]{"x", "y"});
        NodeClass.Position[] IntegerSubNode_positions = MatchRuleRegistry.findPositions(lookup, IntegerSubNode.class, new String[]{"x", "y"});
        NodeClass.Position[] IntegerMulNode_positions = MatchRuleRegistry.findPositions(lookup, IntegerMulNode.class, new String[]{"x", "y"});
        NodeClass.Position[] FloatAddNode_positions = MatchRuleRegistry.findPositions(lookup, FloatAddNode.class, new String[]{"x", "y"});
        NodeClass.Position[] FloatSubNode_positions = MatchRuleRegistry.findPositions(lookup, FloatSubNode.class, new String[]{"x", "y"});
        NodeClass.Position[] FloatMulNode_positions = MatchRuleRegistry.findPositions(lookup, FloatMulNode.class, new String[]{"x", "y"});
        NodeClass.Position[] OrNode_positions = MatchRuleRegistry.findPositions(lookup, OrNode.class, new String[]{"x", "y"});
        NodeClass.Position[] XorNode_positions = MatchRuleRegistry.findPositions(lookup, XorNode.class, new String[]{"x", "y"});
        NodeClass.Position[] AndNode_positions = MatchRuleRegistry.findPositions(lookup, AndNode.class, new String[]{"x", "y"});
        NodeClass.Position[] PiNode_positions = MatchRuleRegistry.findPositions(lookup, PiNode.class, new String[]{"object"});
        NodeClass.Position[] WriteNode_positions = MatchRuleRegistry.findPositions(lookup, WriteNode.class, new String[]{"object", "location", "value"});

        // CheckStyle: stop line length check
        List<MatchStatement> statements = Collections.unmodifiableList(Arrays.asList(
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerBelowNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerBelowNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerEqualsNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerLessThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerBelowNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(IntegerBelowNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerBelowNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatEqualsNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatEqualsNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("ifCompareCompressedMemory", new MatchPattern(IfNode.class, null, new MatchPattern(FloatLessThanNode.class, "compare", new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatLessThanNode_positions, true), IfNode_positions, true), MatchGenerator_ifCompareCompressedMemory.instance, ifCompareCompressedMemory_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerSubNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerSubNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), IntegerMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), IntegerMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatSubNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatSubNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), FloatMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), FloatMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), OrNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), OrNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), XorNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), XorNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern("value", false), new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), AndNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern(ReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), new MatchPattern("value", false), AndNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerAddNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerSubNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerSubNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), IntegerMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(IntegerMulNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), IntegerMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatAddNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatAddNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatSubNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatSubNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), FloatMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(FloatMulNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), FloatMulNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), OrNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(OrNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), OrNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), XorNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(XorNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), XorNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern("value", false), new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), AndNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("binaryReadCompressed", new MatchPattern(AndNode.class, null, new MatchPattern(FloatingReadNode.class, "access", new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), new MatchPattern("value", false), AndNode_positions, true), MatchGenerator_binaryReadCompressed.instance, binaryReadCompressed_arguments),
            new MatchStatement("readCompressed", new MatchPattern(ReadNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), MatchGenerator_readCompressed.instance, readCompressed_arguments),
            new MatchStatement("readCompressed", new MatchPattern(ReadNode.class, null, new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), ReadNode_positions, true), MatchGenerator_readCompressed.instance, readCompressed_arguments),
            new MatchStatement("readCompressed", new MatchPattern(FloatingReadNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), MatchGenerator_readCompressed.instance, readCompressed_arguments),
            new MatchStatement("readCompressed", new MatchPattern(FloatingReadNode.class, null, new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), FloatingReadNode_positions, true), MatchGenerator_readCompressed.instance, readCompressed_arguments),
            new MatchStatement("writeCompressed", new MatchPattern(WriteNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), new MatchPattern("value", false), WriteNode_positions, true), MatchGenerator_writeCompressed.instance, writeCompressed_arguments),
            new MatchStatement("writeCompressed", new MatchPattern(WriteNode.class, null, new MatchPattern(PiNode.class, null, new MatchPattern(CompressionNode.class, "compress", new MatchPattern("object", false), CompressionNode_positions, true), PiNode_positions, true), new MatchPattern(ConstantLocationNode.class, "location", false), new MatchPattern("value", false), WriteNode_positions, true), MatchGenerator_writeCompressed.instance, writeCompressed_arguments)
        ));
        // CheckStyle: resume line length check
        return statements;
    }

}
